﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
#Event: Initialized(Success As Boolean)
#Event: ServiceResolved(ServiceEvent1 As JmDNS_ServiceEvent)

Sub Class_Globals
	Private mJmDNS As JmDNS
	Private mMulticastLock As MulticastLock
	Private mParent As Object
	Private mServiceListener As JmDNS_ServiceListener
	Private mServiceName As String
	Private mServiceType As String
	Private mSubNameInitialized As String
	Private mSubNameServiceResolved As String
	Private mWifiManager As WifiManager
End Sub

Public Sub Initialize(Parent As Object, EventName As String, LocalIpAddress As String)
	mParent=Parent
	mSubNameInitialized=EventName&"_Initialized"
	mSubNameServiceResolved=EventName&"_ServiceResolved"
	
	mWifiManager.Initialize
	mMulticastLock=mWifiManager.CreateMulticastLock("mMulticastLock")
	mMulticastLock.SetReferenceCounted(False)
	
	Dim LocalAddressParts() As String=Regex.Split("\.", LocalIpAddress)
	If LocalAddressParts.Length=4 Then
		Dim AddressBytes(4) As Byte
		For i=0 To 3
			AddressBytes(i)=LocalAddressParts(i)
		Next
		mJmDNS.Initialize2("mJmDNS", AddressBytes)
	Else
		Log("Failed to convert string ip address to bytes")
	End If
End Sub

public Sub IsValidIp4(String1 As String) As Boolean
	Dim Matcher1 As Matcher = Regex.Matcher("^(\d+)\.(\d+)\.(\d+)\.(\d+)$", String1)
	If Matcher1.Find = False Then Return False
	For i = 1 To 4
		If Matcher1.Group(i) > 255 Or Matcher1.Group(i) < 0 Then Return False
	Next
	Return True
End Sub

private Sub mJmDNS_Initialized(Success As Boolean)
	If Not(IsPaused(mParent)) And  SubExists(mParent, mSubNameInitialized) Then
		CallSub2(mParent, mSubNameInitialized, Success)
	End If
End Sub

private Sub mServiceListener_ServiceAdded(ServiceEvent1 As JmDNS_ServiceEvent)
	Log("mServiceListener_ServiceAdded: "&ServiceEvent1.Name)
	
End Sub

private Sub mServiceListener_ServiceRemoved(ServiceEvent1 As JmDNS_ServiceEvent)
	Log("mServiceListener_ServiceRemoved: "&ServiceEvent1.Name)
	
End Sub

private Sub mServiceListener_ServiceResolved(ServiceEvent1 As JmDNS_ServiceEvent)
	Log("mServiceListener_ServiceResolved: "&ServiceEvent1.Name)
	
	If ServiceEvent1.Name=mServiceName Then
		'	this is the service we are looking for
		Dim ServiceInfo1 As JmDNS_ServiceInfo=ServiceEvent1.Info
		If ServiceInfo1.IsInitialized Then
			
			'	HostAddresses() is an array of IP4 and/or IP6 addresses
			For i=0 To ServiceInfo1.HostAddresses.Length-1
				If IsValidIp4(ServiceInfo1.HostAddresses(i)) Then
					'	this is an IP4 address
					
					If Not(IsPaused(mParent)) And  SubExists(mParent, mSubNameServiceResolved) Then
						CallSub2(mParent, mSubNameServiceResolved, ServiceEvent1)
					End If
					
					Stop
				End If
				
			Next
			
		Else
			Log("ServiceInfo is not initialized")
		End If
	End If
	

End Sub

public Sub Resolve(ServiceType As String, ServiceName As String)
	If Not(mMulticastLock.IsHeld) Then
		mMulticastLock.Acquire
	End If
	mServiceName=ServiceName
	mServiceType=ServiceType
	mServiceListener.Initialize("mServiceListener")
	mJmDNS.AddServiceListener(ServiceType, mServiceListener)
End Sub

public Sub Stop
	If mServiceListener.IsInitialized Then
		mJmDNS.RemoveServiceListener(mServiceType, mServiceListener)
	End If
	If mMulticastLock.IsHeld Then
		mMulticastLock.Release
	End If
End Sub
